-- Riky47#3355 | richiitalia

-- Services
local RunService = game:GetService("RunService")
local UIS = game:GetService("UserInputService")
local RepStorage = game:GetService("ReplicatedStorage")
local GuiService = game:GetService("GuiService")
local Players = game:GetService("Players")

-- Modules and Remotes
local Sliders = require(script:WaitForChild("NumberSlider"))
local ScreenSpace = require(script:WaitForChild("ScreenSpace"))
local CatalogCore = RepStorage:WaitForChild("CatalogCore")

-- Gui
local gui = script.Parent
local subCat = gui:WaitForChild("SubCat")
local Lateral = gui:WaitForChild("Lateral")

-- Main
local Main = gui:WaitForChild("Main")
local Catalog = Main:WaitForChild("Catalog")
local Colors = Main:WaitForChild("Colors")
local Scale = Main:WaitForChild("Scale")
local Used = Main:WaitForChild("Used")
local Save = Main:WaitForChild("Save")
local Cart = Main:WaitForChild("Cart")

-- Header
local Header = Main:WaitForChild("Header")
local Category = Header:WaitForChild("Category")
local subCategory = Header:WaitForChild("SubCategory")

-- Selected Category
local lastCat = nil
local lastSubCat = nil

-- Category to search
local CatalogCat = ""
local CatalogSubCat = ""

-- Animation and Bundles
local animationToSet = ""
local bundleToSet = ""

-- Colors
local colorsList = Colors:WaitForChild("List")
local colorsParts = Colors:WaitForChild("Parts")

local colorsTable = {
	["Head"] = "",
	["Torso"] = "",
	["LeftArm"] = "",
	["RightArm"] = "",
	["LeftLeg"] = "",
	["RightLeg"] = "",
	["All"] = ""
}

local partToColor = "Head"
local lastColorPart = colorsParts:WaitForChild("Head"):WaitForChild("Selected")
local lastColor = nil

-- Scale
local scaleList = Scale:WaitForChild("List")

-- Filter
local Filter = Catalog:WaitForChild("Filter"):WaitForChild("List")
local filterData = {
	["MaxPrice"] = "",
	["MinPrice"] = "",
	["Genres"] = "",
	["CreatorType"] = "",
	["CreatorName"] = "",
	["SortType"] = "Relevance",
	["SortAggregation"] = "AllTime"
}

-- Variables
local DEPTH = 9
local CAMERA_OFFSET = 0.81
local CAMERA_BIND = "CameraBind"

local player = Players.LocalPlayer
local wearingAssets = nil

isMobile = false
if UIS.TouchEnabled and not UIS.KeyboardEnabled and not UIS.MouseEnabled and not UIS.GamepadEnabled and not GuiService:IsTenFootInterface() then
	isMobile = true
end

local function processRequest(arg1, arg2)
	--[[
	if arg1 == "Used" then
		print("stopped on", arg1, arg2)
	elseif arg1 == "Cart" then
		print("stopped on", arg1, arg2)
	elseif arg1 == "Save" then
		print("stopped on", arg1, arg2)
	else
		if arg2 == "Colors" then
			print("stopped on", arg1, arg2)
		elseif arg2 == "Scale" then
			print("stopped on", arg1, arg2)
		else
			print("fired server with", arg1, arg2)
		end
	end]]
	print("fired server with", arg1, arg2)
end

local function swithc(frame)
	for _, v in pairs(Main:GetChildren()) do
		if v.Name ~= "Header" and not v:IsA("UIListLayout") then
			v.Visible = false
		end
	end
	if frame then
		frame.Visible = true
	end
end

function Click(btn, isCat)
	local selected = btn:FindFirstChild("Selected")
	local key = btn:FindFirstChild("Key")
	local specialKey = btn:FindFirstChild("specialKey")
	
	if selected and key then
		local last = isCat and lastCat or lastSubCat
		if last ~= selected then
			if last then
				last.Visible = false
			end
			selected.Visible = true
			--last = selected
		
			if isCat then
				lastCat = selected
				
				local directory = subCat:FindFirstChild(btn.Name)
				for _, i in pairs(subCategory:GetChildren()) do
					if i:IsA("GuiButton") then
						i:Destroy()
					end
				end
				
				local lower = nil
				if directory then
					--subCategory.Visible = true
					swithc(Catalog)				
					
					for _, i in pairs(directory:GetChildren()) do
						local clo = i:Clone()
						clo.Parent = subCategory
						clo.Visible = true
						
						if lower then
							if clo.LayoutOrder < lower.LayoutOrder then
								lower = clo
							end
						else
							lower = clo
						end
					end		
				else
					--subCategory.Visible = false
					if key.Value == "Save" then
						swithc(Save)
					elseif key.Value == "Cart" then
						swithc(Cart)
					elseif key.Value == "Used" then
						swithc(Used)
					else
						swithc()
					end				
					--Catalog.Visible = false
				end
				
				if CatalogCat ~= key.Value then
					CatalogCat = key.Value
					if lastSubCat then
						lastSubCat.Visible = false
					end
					CatalogSubCat = ""
				end	
				
				if lower then
					print("setting", lower.Name)
					Click(lower, false)
				end
			else
				lastSubCat = selected
						
				if specialKey then
					if specialKey.Value == "Anim" then
						animationToSet = btn.Name
						print("setted animationToSet to", btn.Name)
					elseif specialKey.Value == "Bundl" then
						bundleToSet = btn.Name
						print("setted bundleToSet to", btn.Name)
					end
				end
				
				if key.Value == "Colors" then
					swithc(Colors)
				elseif key.Value == "Scale" then
					swithc(Scale)
				elseif CatalogSubCat ~= key.Value then
					CatalogSubCat = key.Value
					
					if CatalogCat ~= "" and CatalogSubCat ~= "" then			
						processRequest(CatalogCat, CatalogSubCat)
					end
				end
			end
		end
	end
end

local function btnSetup(btn, isCat)
	local tip = btn:FindFirstChild("Tooltip")
	
	if btn:IsA("GuiButton") and tip then
		btn.MouseButton1Click:Connect(function()
			Click(btn, isCat)
		end)
		btn.MouseEnter:Connect(function()
			if not isMobile then
				tip.Visible = true
			end
		end)
		btn.MouseLeave:Connect(function()
			tip.Visible = false
		end)
	end
end

local function update(obj, parent)
	if obj:IsA("GuiButton") then
		local dir = parent:GetChildren()
		local num = 0
		for _, v in pairs(dir) do
			if v:IsA("GuiButton") then
				num += 1
			end
		end
		for _, v in pairs(dir) do
			if v:IsA("GuiButton") then
				v.Size = UDim2.new(0, parent.AbsoluteSize.X/num, 0.9, 0)
			end
		end
	end
end

local function getCameraOffsetCFrame()
	local char = player.Character
	if char then
		local root = char.PrimaryPart or char:FindFirstChild("HumanoidRootPart")
		
		local ViewSizeX = ScreenSpace.ViewSizeX()
		local ViewSizeY = ScreenSpace.ViewSizeY()
		local offset = ScreenSpace.ScreenToWorld(CAMERA_OFFSET * ViewSizeX, ViewSizeY/2, -DEPTH)
		local cameraCFrame = root.CFrame * offset
		local lookCFrame = root.CFrame * Vector3.new(offset.X, offset.Y, DEPTH)
		return CFrame.new(cameraCFrame, lookCFrame)
	end
end

local function switchFilter(isSub, arg)	
	for _, v in pairs(Filter:GetChildren()) do
		local name = v.Name
		local name2 = "sub" .. arg
				
		if isSub then
			if v:IsA("GuiButton") and name == arg then
				v.Visible = not v.Visible
			end
		else
			if v:IsA("GuiButton") and name == name2 then
				v.Visible = not v.Visible
			end
		end
	end
end

for _, v in pairs(Category:GetChildren()) do
	btnSetup(v, true)
end

for _, v in pairs(Lateral:GetChildren()) do
	local tip = v:FindFirstChild("Tooltip")
	
	if v:IsA("GuiButton") then
		v.MouseButton1Click:Connect(function()
			local nam = v.Name:lower()
			if nam == "close" then
				local camera = workspace.CurrentCamera
				
				Main:TweenPosition(UDim2.new(-0.7, 0, 0, 0), Enum.EasingDirection.Out, Enum.EasingStyle.Quint)
				Lateral:TweenPosition(UDim2.new(0.7, 0, -0.08, -50), Enum.EasingDirection.Out, Enum.EasingStyle.Quint)
				
				wait(2)
				
				Main.Visible = false
				Main.Visible = false
				
				wait(2)
				
				Main.Visible = true
				Main.Visible = true
				
				Main:TweenPosition(UDim2.new(0, 0, 0, 0), Enum.EasingDirection.In, Enum.EasingStyle.Quint)
				Lateral:TweenPosition(UDim2.new(0.7, 0, 0, 0), Enum.EasingDirection.In, Enum.EasingStyle.Quint)
					
				RunService:BindToRenderStep(CAMERA_BIND, Enum.RenderPriority.Camera.Value, function()
					camera.CFrame = getCameraOffsetCFrame()
				end)
			elseif nam == "reset" then
				
			elseif nam == "char" then
				
			else
				print("Not defined button.")
			end
		end)
		v.MouseEnter:Connect(function()
			tip.Visible = true
		end)
		v.MouseLeave:Connect(function()
			tip.Visible = false
		end)
	end
end

for _, v in pairs(colorsList:GetChildren()) do
	if v:IsA("GuiButton") then
		v.MouseButton1Click:Connect(function()
			if colorsTable[partToColor] then--and colorsTable[partToColor] ~= v.Name then
				if partToColor == "All" then
					for i, _ in pairs(colorsTable) do
						colorsTable[i] = v.Name
					end
				else
					colorsTable[partToColor] = v.Name
				end
				
				if lastColor then
					lastColor.Visible = false
				end
				lastColor = v:FindFirstChild("Selected")
				lastColor.Visible = true
				
				print("color", partToColor, colorsTable[partToColor])
				CatalogCore:InvokeServer("color", partToColor, colorsTable[partToColor])
			end
		end)
	end
end

for _, v in pairs(colorsParts:GetChildren()) do
	if v:IsA("GuiButton") then
		v.MouseButton1Click:Connect(function()
			if v.Name ~= partToColor then
				partToColor = v.Name
				if lastColorPart then
					lastColorPart.Visible = false
				end
				lastColorPart = v:FindFirstChild("Selected")
				lastColorPart.Visible = true
				
				if lastColor then
					lastColor.Visible = false
					lastColor = nil
				end
				if colorsTable[partToColor] and colorsTable[partToColor] ~= "" then
					local color = colorsList:FindFirstChild(colorsTable[partToColor]):FindFirstChild("Selected")
					color.Visible = true
					lastColor = color
				end
			end
		end)
	end
end

for _, v in pairs(Filter:GetChildren()) do	
	local name = v.Name
	if v:IsA("GuiButton") and string.sub(name, 1, 3) ~= "sub" then
		v.MouseButton1Click:Connect(function()
			switchFilter(false, name)
		end)
	elseif v:IsA("TextBox") then
		local key = v:FindFirstChild("key")
		local TB = v:FindFirstAncestorWhichIsA("TextBox")
		if TB and key then
			v:GetPropertyChangedSignal("Text"):Connect(function()
				if filterData[key.Value] then
					filterData[key.Value] = v.Text
					print(key.Value, filterData[key.Value])
				end
			end)
		end
	elseif v:IsA("GuiButton") and string.sub(name, 1, 3) == "sub" then
		local key = v:FindFirstChild("Key")		
		v.MouseButton1Click:Connect(function()
			switchFilter(true, name)
			local item = Filter:FindFirstChild(string.gsub(name, "sub", "")) 
			if item and key then
				local title = v:FindFirstChild("Title")
				local value = item:FindFirstChild("Value")
				local itemKey = item:FindFirstChild("Key")
				local keyValue = key.Value
				
				if filterData[itemKey.Value] then
					filterData[itemKey.Value] = keyValue
					print(itemKey.Value, filterData[itemKey.Value])
				end
				
				if value and title then
					value.Text = title.text
				end
			end
		end)
	end
end

local heightSliderFrame = Sliders.new(function(newValue, oldValue)
	CatalogCore:InvokeServer("scale", "BodyHeightScale", newValue)
end, scaleList.Height, 90, 105, true)
local widthSliderFrame = Sliders.new(function(newValue, oldValue)
	CatalogCore:InvokeServer("scale", "BodyWidthScale", newValue)
end, scaleList.Width, 70, 100, true)
local headSliderFrame = Sliders.new(function(newValue, oldValue)
	CatalogCore:InvokeServer("scale", "HeadScale", newValue)
end, scaleList.Head, 95, 100, true)
local proportionSliderFrame = Sliders.new(function(newValue, oldValue)
	CatalogCore:InvokeServer("scale", "BodyProportionScale", newValue)
end, scaleList.Proportion, 0, 100, true)
local bodySliderFrame = Sliders.new(function(newValue, oldValue)
	CatalogCore:InvokeServer("scale", "BodyTypeScale", newValue)
end, scaleList.BodyType, 0, 100, true)

subCategory.ChildAdded:Connect(function(obj)
	update(obj, subCategory)
	btnSetup(obj, false)
end)

subCategory.ChildRemoved:Connect(function(obj)
	update(obj, subCategory)
end)

Category.ChildAdded:Connect(function(obj)
	update(obj, Category)
	--already setupped
end)

Category.ChildRemoved:Connect(function(obj)
	update(obj, Category)
end)

Click(Category:WaitForChild("Accessories"), true)

do
	local success = pcall(function()
		wearingAssets = Players:GetCharacterAppearanceInfoAsync(player.UserId)
	end)
	if not success then
		print("failed to load")
	end
end

heightSliderFrame:Set(wearingAssets.scales.height * 100)
widthSliderFrame:Set(wearingAssets.scales.width * 100)
headSliderFrame:Set(wearingAssets.scales.head * 100)
proportionSliderFrame:Set(wearingAssets.scales.proportion * 100)
bodySliderFrame:Set(wearingAssets.scales.bodyType * 100)
